wfopen german_housing_data

'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXestimationXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

'declarations

matrix(13,2) estcoefs_housing_pre
matrix(13,2) estcoefs_housing_post

'estimation

'pre-break
smpl 1971Q1 1990Q1
equation eq1.ls(arma=cls, optmethod=legacy) ger_housing c ar(1) ar(2) ma(4) ma(12)
eq1.makeresids res_ger_housing_pre
estcoefs_housing_pre(1,1)=eq1.@coefs(2)
estcoefs_housing_pre(2,1)=eq1.@coefs(3)
estcoefs_housing_pre(4,2)=eq1.@coefs(4)
estcoefs_housing_pre(12,2)=eq1.@coefs(5)
estcoefs_housing_pre(13,1)=eq1.@se
estcoefs_housing_pre(13,2)=eq1.@sddep

smpl 1990Q2 2013Q4
equation eq1.ls(arma=cls, optmethod=legacy) ger_housing c ar(1) ar(2) ar(5) ma(4)
eq1.makeresids res_ger_housing_post
estcoefs_housing_post(1,1)=eq1.@coefs(2)
estcoefs_housing_post(2,1)=eq1.@coefs(3)
estcoefs_housing_post(5,1)=eq1.@coefs(4)
estcoefs_housing_post(4,2)=eq1.@coefs(5)
estcoefs_housing_post(13,1)=eq1.@se
estcoefs_housing_post(13,2)=eq1.@sddep


'save the estimated coefficients in text files 'note that one has to write the data in transposed form

estcoefs_housing_pre.write(t=txt,t) estcoefs_housing_pre.txt
estcoefs_housing_post.write(t=txt,t) estcoefs_housing_post.txt


'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXbootstrapXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

'declarations
!R=5000
series y=0
series res=0

matrix(13,!R*2) bootcoefs_housing_pre
matrix(13,!R*2) bootcoefs_housing_post

'pre-break
smpl 1960Q1 2013Q4
!maxlag=2
for !j=1 to !R
	y=ger_housing 
	res_ger_housing_pre.resample(fixna,suffix="res") 
	smpl 1970Q1 1990Q1
	res=@recode(res=na,0,res) 
	for !i=@dtoo("1971Q1")+!maxlag+10 to @dtoo("1990Q1") 
		y(!i)=-0.001183+1.769046087*y(!i-1)-0.810706671*y(!i-2)-0.75104*res(!i-4)-0.183450752*res(!i-12)+res(!i)
	next
	equation eq1.ls(arma=cls, optmethod=legacy) y c ar(1) ar(2) ma(4) ma(12)
	bootcoefs_housing_pre(1,!j*2-1)=eq1.@coefs(2)
	bootcoefs_housing_pre(2,!j*2-1)=eq1.@coefs(3)
	bootcoefs_housing_pre(4,!j*2)=eq1.@coefs(4)
	bootcoefs_housing_pre(12,!j*2)=eq1.@coefs(5)
	bootcoefs_housing_pre(13,!j*2-1)=eq1.@se
	bootcoefs_housing_pre(13,!j*2)=eq1.@sddep
next

'post-break
for !j=1 to !R
	smpl 1960Q1 2013Q4 
	y=ger_housing
	res_ger_housing_post.resample(fixna,suffix="res") 
	res=@recode(res=na,0,res)
	smpl 1990Q2 2013Q4 
	for !i=@dtoo("1990Q2") to @dtoo("2013Q4")
		y(!i)=-0.003805+1.439626188*y(!i-1)-0.336882728*y(!i-2)-0.116134033*y(!i-5)-0.90541686*res(!i-4)+res(!i)		
	next
	equation eq1.ls(arma=cls, optmethod=legacy) y c ar(1) ar(2) ar(5) ma(4)
	bootcoefs_housing_post(1,!j*2-1)=eq1.@coefs(2)
	bootcoefs_housing_post(2,!j*2-1)=eq1.@coefs(3)
	bootcoefs_housing_post(5,!j*2-1)=eq1.@coefs(4)
	bootcoefs_housing_post(4,!j*2)=eq1.@coefs(5)
	bootcoefs_housing_post(13,!j*2-1)=eq1.@se
	bootcoefs_housing_post(13,!j*2)=eq1.@sddep
next


'save the bootstrapped coefficients in text files 'note that one has to write the data in transposed form

bootcoefs_housing_pre.write(t=txt,t) bootcoefs_housing_pre.txt
bootcoefs_housing_post.write(t=txt,t) bootcoefs_housing_post.txt


