%CITATION Strohsal, T., Proao, C.R., Wolters, J. (2015): 
%"Characterizing the Financial Cycle: Evidence from a Frequency Domain Analysis"
%Discussion Paper, Deutsche Bundesbank, No 22/2015.

function[frequency,spectrum]=time_to_frequency(ar,ma,grid,residvar)

frequency=zeros(grid+1,1);
spectrum=zeros(grid+1,1);
for j=2:(grid+1)
    frequency(j)=(j-1)*(pi/grid);
end
fu=residvar/(2*pi);
lambda=0;
vector_of_exps=[exp(-i*lambda*0) exp(-i*lambda*1) exp(-i*lambda*2) exp(-i*lambda*3)...
                exp(-i*lambda*4) exp(-i*lambda*5) exp(-i*lambda*6) exp(-i*lambda*7)...
                exp(-i*lambda*8) exp(-i*lambda*9) exp(-i*lambda*10) exp(-i*lambda*11)...
                exp(-i*lambda*12)];
spectrum(1)=fu*((abs(ma*transpose(vector_of_exps))^2)/(abs(ar*transpose(vector_of_exps))^2));
for j=2:(grid+1)
    lambda=(j-1)*(pi/grid);
    vector_of_exps=[exp(-i*lambda*0) exp(-i*lambda*1) exp(-i*lambda*2) exp(-i*lambda*3)...
                    exp(-i*lambda*4) exp(-i*lambda*5) exp(-i*lambda*6) exp(-i*lambda*7)...
                    exp(-i*lambda*8) exp(-i*lambda*9) exp(-i*lambda*10) exp(-i*lambda*11)...
                    exp(-i*lambda*12)];
    spectrum(j)=fu*((abs(ma*transpose(vector_of_exps))^2)/(abs(ar*transpose(vector_of_exps))^2));
end

end